<HTML>
<BODY BGCOLOR="white">
<PRE>
<FONT color="green">001</FONT>    /*<a name="line.1"></a>
<FONT color="green">002</FONT>     * =============================================================================<a name="line.2"></a>
<FONT color="green">003</FONT>     * Simplified BSD License, see http://www.opensource.org/licenses/<a name="line.3"></a>
<FONT color="green">004</FONT>     * -----------------------------------------------------------------------------<a name="line.4"></a>
<FONT color="green">005</FONT>     * Copyright (c) 2008-2009, Marco Terzer, Zurich, Switzerland<a name="line.5"></a>
<FONT color="green">006</FONT>     * All rights reserved.<a name="line.6"></a>
<FONT color="green">007</FONT>     * <a name="line.7"></a>
<FONT color="green">008</FONT>     * Redistribution and use in source and binary forms, with or without <a name="line.8"></a>
<FONT color="green">009</FONT>     * modification, are permitted provided that the following conditions are met:<a name="line.9"></a>
<FONT color="green">010</FONT>     * <a name="line.10"></a>
<FONT color="green">011</FONT>     *     * Redistributions of source code must retain the above copyright notice, <a name="line.11"></a>
<FONT color="green">012</FONT>     *       this list of conditions and the following disclaimer.<a name="line.12"></a>
<FONT color="green">013</FONT>     *     * Redistributions in binary form must reproduce the above copyright <a name="line.13"></a>
<FONT color="green">014</FONT>     *       notice, this list of conditions and the following disclaimer in the <a name="line.14"></a>
<FONT color="green">015</FONT>     *       documentation and/or other materials provided with the distribution.<a name="line.15"></a>
<FONT color="green">016</FONT>     *     * Neither the name of the Swiss Federal Institute of Technology Zurich <a name="line.16"></a>
<FONT color="green">017</FONT>     *       nor the names of its contributors may be used to endorse or promote <a name="line.17"></a>
<FONT color="green">018</FONT>     *       products derived from this software without specific prior written <a name="line.18"></a>
<FONT color="green">019</FONT>     *       permission.<a name="line.19"></a>
<FONT color="green">020</FONT>     * <a name="line.20"></a>
<FONT color="green">021</FONT>     * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" <a name="line.21"></a>
<FONT color="green">022</FONT>     * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE <a name="line.22"></a>
<FONT color="green">023</FONT>     * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE <a name="line.23"></a>
<FONT color="green">024</FONT>     * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE <a name="line.24"></a>
<FONT color="green">025</FONT>     * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR <a name="line.25"></a>
<FONT color="green">026</FONT>     * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF <a name="line.26"></a>
<FONT color="green">027</FONT>     * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS <a name="line.27"></a>
<FONT color="green">028</FONT>     * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN <a name="line.28"></a>
<FONT color="green">029</FONT>     * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) <a name="line.29"></a>
<FONT color="green">030</FONT>     * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE <a name="line.30"></a>
<FONT color="green">031</FONT>     * POSSIBILITY OF SUCH DAMAGE.<a name="line.31"></a>
<FONT color="green">032</FONT>     * =============================================================================<a name="line.32"></a>
<FONT color="green">033</FONT>     */<a name="line.33"></a>
<FONT color="green">034</FONT>    package ch.javasoft.util.map;<a name="line.34"></a>
<FONT color="green">035</FONT>    <a name="line.35"></a>
<FONT color="green">036</FONT>    import java.io.Serializable;<a name="line.36"></a>
<FONT color="green">037</FONT>    import java.lang.reflect.Method;<a name="line.37"></a>
<FONT color="green">038</FONT>    import java.util.ArrayList;<a name="line.38"></a>
<FONT color="green">039</FONT>    import java.util.Collection;<a name="line.39"></a>
<FONT color="green">040</FONT>    import java.util.Collections;<a name="line.40"></a>
<FONT color="green">041</FONT>    import java.util.Iterator;<a name="line.41"></a>
<FONT color="green">042</FONT>    import java.util.LinkedHashMap;<a name="line.42"></a>
<FONT color="green">043</FONT>    import java.util.Map;<a name="line.43"></a>
<FONT color="green">044</FONT>    import java.util.NoSuchElementException;<a name="line.44"></a>
<FONT color="green">045</FONT>    import java.util.Set;<a name="line.45"></a>
<FONT color="green">046</FONT>    <a name="line.46"></a>
<FONT color="green">047</FONT>    /**<a name="line.47"></a>
<FONT color="green">048</FONT>     * Default implementation for a mutable {@link MultiValueMap}. <a name="line.48"></a>
<FONT color="green">049</FONT>     * &lt;p&gt;<a name="line.49"></a>
<FONT color="green">050</FONT>     * The standard implementation is backed by a {@link LinkedHashMap} containing<a name="line.50"></a>
<FONT color="green">051</FONT>     * an {@link ArrayList} per key. The backing map and collection can be changed<a name="line.51"></a>
<FONT color="green">052</FONT>     * by overriding {@link #createMap()} and {@link #createCollection(Object)}, <a name="line.52"></a>
<FONT color="green">053</FONT>     * respectively.<a name="line.53"></a>
<FONT color="green">054</FONT>     */<a name="line.54"></a>
<FONT color="green">055</FONT>    public class DefaultMultiValueMap&lt;K, V&gt; extends AbstractMutableMultiValueMap&lt;K, V&gt; <a name="line.55"></a>
<FONT color="green">056</FONT>            implements Cloneable, Serializable {<a name="line.56"></a>
<FONT color="green">057</FONT>                    <a name="line.57"></a>
<FONT color="green">058</FONT>            private static final long serialVersionUID = 8019175851546861383L;<a name="line.58"></a>
<FONT color="green">059</FONT>            <a name="line.59"></a>
<FONT color="green">060</FONT>            private final Map&lt;K, Collection&lt;V&gt;&gt; map;<a name="line.60"></a>
<FONT color="green">061</FONT>            <a name="line.61"></a>
<FONT color="green">062</FONT>            /**<a name="line.62"></a>
<FONT color="green">063</FONT>             * Constructor for an empty multi value map<a name="line.63"></a>
<FONT color="green">064</FONT>             */<a name="line.64"></a>
<FONT color="green">065</FONT>            public DefaultMultiValueMap() {<a name="line.65"></a>
<FONT color="green">066</FONT>                    map = createMap();<a name="line.66"></a>
<FONT color="green">067</FONT>            }<a name="line.67"></a>
<FONT color="green">068</FONT>            /**<a name="line.68"></a>
<FONT color="green">069</FONT>             * Constructor for a multi value map based on an existing one<a name="line.69"></a>
<FONT color="green">070</FONT>             */<a name="line.70"></a>
<FONT color="green">071</FONT>            public DefaultMultiValueMap(MultiValueMap&lt;? extends K, ? extends V&gt; copy) {<a name="line.71"></a>
<FONT color="green">072</FONT>                    map = createMap();<a name="line.72"></a>
<FONT color="green">073</FONT>                    for (final K key : copy.keySet()) {<a name="line.73"></a>
<FONT color="green">074</FONT>                            final Collection&lt;V&gt; coll = createCollection(key);<a name="line.74"></a>
<FONT color="green">075</FONT>                            coll.addAll(copy.get(key));<a name="line.75"></a>
<FONT color="green">076</FONT>                            map.put(key, coll);<a name="line.76"></a>
<FONT color="green">077</FONT>                    }<a name="line.77"></a>
<FONT color="green">078</FONT>            }<a name="line.78"></a>
<FONT color="green">079</FONT>            <a name="line.79"></a>
<FONT color="green">080</FONT>            /**<a name="line.80"></a>
<FONT color="green">081</FONT>             * Constructor for a multi value map based on the given collection map. The<a name="line.81"></a>
<FONT color="green">082</FONT>             * submitted map and its contents are not copied, thus, changes to it will<a name="line.82"></a>
<FONT color="green">083</FONT>             * also affect the newly created multi value map instance. To copy the<a name="line.83"></a>
<FONT color="green">084</FONT>             * submitted map, {@link #createFromCollectionMap(Map)} can be used.<a name="line.84"></a>
<FONT color="green">085</FONT>             * <a name="line.85"></a>
<FONT color="green">086</FONT>             * @param       collectionMap the map to use for this multi value map<a name="line.86"></a>
<FONT color="green">087</FONT>             */<a name="line.87"></a>
<FONT color="green">088</FONT>            public DefaultMultiValueMap(Map&lt;K, Collection&lt;V&gt;&gt; collectionMap) {<a name="line.88"></a>
<FONT color="green">089</FONT>                    map = collectionMap;<a name="line.89"></a>
<FONT color="green">090</FONT>            }<a name="line.90"></a>
<FONT color="green">091</FONT>    <a name="line.91"></a>
<FONT color="green">092</FONT>            /**<a name="line.92"></a>
<FONT color="green">093</FONT>             * Creates a multi value map from an existing (single value) map<a name="line.93"></a>
<FONT color="green">094</FONT>             * <a name="line.94"></a>
<FONT color="green">095</FONT>             * @param &lt;K&gt;             the key type<a name="line.95"></a>
<FONT color="green">096</FONT>             * @param &lt;V&gt;             the value type<a name="line.96"></a>
<FONT color="green">097</FONT>             * @param singleMap     the map containing key/value pairs to add to the new map        <a name="line.97"></a>
<FONT color="green">098</FONT>             * @return      a new multi value map containing the entries of the submitted<a name="line.98"></a>
<FONT color="green">099</FONT>             *                      single value map<a name="line.99"></a>
<FONT color="green">100</FONT>             */<a name="line.100"></a>
<FONT color="green">101</FONT>            public static &lt;K, V&gt; DefaultMultiValueMap&lt;K, V&gt; createFromSingleValueMap(Map&lt;? extends K, ? extends V&gt; singleMap) {<a name="line.101"></a>
<FONT color="green">102</FONT>                    final DefaultMultiValueMap&lt;K, V&gt; map = new DefaultMultiValueMap&lt;K, V&gt;();<a name="line.102"></a>
<FONT color="green">103</FONT>                    for (final K key : singleMap.keySet()) {<a name="line.103"></a>
<FONT color="green">104</FONT>                            map.add(key, singleMap.get(key));<a name="line.104"></a>
<FONT color="green">105</FONT>                    }<a name="line.105"></a>
<FONT color="green">106</FONT>                    return map;<a name="line.106"></a>
<FONT color="green">107</FONT>            }<a name="line.107"></a>
<FONT color="green">108</FONT>            /**<a name="line.108"></a>
<FONT color="green">109</FONT>             * Creates a multi value map from an existing collection map. <a name="line.109"></a>
<FONT color="green">110</FONT>             * <a name="line.110"></a>
<FONT color="green">111</FONT>             * @param &lt;K&gt;                     the key type<a name="line.111"></a>
<FONT color="green">112</FONT>             * @param &lt;V&gt;                     the value type<a name="line.112"></a>
<FONT color="green">113</FONT>             * @param collectionMap the map containing key/list-of-value entries to add <a name="line.113"></a>
<FONT color="green">114</FONT>             *                                              to the new map  <a name="line.114"></a>
<FONT color="green">115</FONT>             * @return      a new multi value map containing the entries of the submitted<a name="line.115"></a>
<FONT color="green">116</FONT>             *                      collection map<a name="line.116"></a>
<FONT color="green">117</FONT>             */<a name="line.117"></a>
<FONT color="green">118</FONT>            public static &lt;K, V&gt; DefaultMultiValueMap&lt;K, V&gt; createFromCollectionMap(Map&lt;? extends K, ? extends Collection&lt;? extends V&gt;&gt; collectionMap) {<a name="line.118"></a>
<FONT color="green">119</FONT>                    final DefaultMultiValueMap&lt;K, V&gt; map = new DefaultMultiValueMap&lt;K, V&gt;();<a name="line.119"></a>
<FONT color="green">120</FONT>                    map.addAllNested(collectionMap);<a name="line.120"></a>
<FONT color="green">121</FONT>                    return map;<a name="line.121"></a>
<FONT color="green">122</FONT>            }<a name="line.122"></a>
<FONT color="green">123</FONT>            <a name="line.123"></a>
<FONT color="green">124</FONT>            /**<a name="line.124"></a>
<FONT color="green">125</FONT>             * Adds the given value to the multi value map<a name="line.125"></a>
<FONT color="green">126</FONT>             * <a name="line.126"></a>
<FONT color="green">127</FONT>             * @param key   the key which identifies the value collection<a name="line.127"></a>
<FONT color="green">128</FONT>             * @param value the value to add<a name="line.128"></a>
<FONT color="green">129</FONT>             * <a name="line.129"></a>
<FONT color="green">130</FONT>             * @return      true if this map has changed, which is usually the case. If sets<a name="line.130"></a>
<FONT color="green">131</FONT>             *                      are used as key collections, however, the method could also <a name="line.131"></a>
<FONT color="green">132</FONT>             *                      return false if the given value already existed.<a name="line.132"></a>
<FONT color="green">133</FONT>             * @throws UnsupportedOperationException if this is an immutable map<a name="line.133"></a>
<FONT color="green">134</FONT>             */<a name="line.134"></a>
<FONT color="green">135</FONT>            @Override<a name="line.135"></a>
<FONT color="green">136</FONT>            public boolean add(K key, V value) {<a name="line.136"></a>
<FONT color="green">137</FONT>                    final Collection&lt;V&gt; coll = getOrCreateCollection(key);<a name="line.137"></a>
<FONT color="green">138</FONT>                    return coll.add(value);<a name="line.138"></a>
<FONT color="green">139</FONT>            }<a name="line.139"></a>
<FONT color="green">140</FONT>            @Override<a name="line.140"></a>
<FONT color="green">141</FONT>            public boolean addAll(K key, Collection&lt;? extends V&gt; values) {<a name="line.141"></a>
<FONT color="green">142</FONT>                    if (values.isEmpty()) return false;<a name="line.142"></a>
<FONT color="green">143</FONT>                    final Collection&lt;V&gt; coll = getOrCreateCollection(key);<a name="line.143"></a>
<FONT color="green">144</FONT>                    return coll.addAll(values);<a name="line.144"></a>
<FONT color="green">145</FONT>            }<a name="line.145"></a>
<FONT color="green">146</FONT>    <a name="line.146"></a>
<FONT color="green">147</FONT>            /**<a name="line.147"></a>
<FONT color="green">148</FONT>             * Returns an unmodifiable value collection.<a name="line.148"></a>
<FONT color="green">149</FONT>             * <a name="line.149"></a>
<FONT color="green">150</FONT>             * @see MultiValueMap#get(Object)<a name="line.150"></a>
<FONT color="green">151</FONT>             */<a name="line.151"></a>
<FONT color="green">152</FONT>            public Collection&lt;V&gt; get(Object key) {<a name="line.152"></a>
<FONT color="green">153</FONT>                    final Collection&lt;V&gt; coll = map.get(key);<a name="line.153"></a>
<FONT color="green">154</FONT>                    if (coll == null) return Collections.emptyList();<a name="line.154"></a>
<FONT color="green">155</FONT>                    return Collections.unmodifiableCollection(coll);<a name="line.155"></a>
<FONT color="green">156</FONT>            }<a name="line.156"></a>
<FONT color="green">157</FONT>            @Override<a name="line.157"></a>
<FONT color="green">158</FONT>            public V getFirst(Object key) {<a name="line.158"></a>
<FONT color="green">159</FONT>                    final Collection&lt;V&gt; coll = map.get(key);<a name="line.159"></a>
<FONT color="green">160</FONT>                    return coll == null ? null : coll.iterator().next();<a name="line.160"></a>
<FONT color="green">161</FONT>            }<a name="line.161"></a>
<FONT color="green">162</FONT>            public int count(Object key) {<a name="line.162"></a>
<FONT color="green">163</FONT>                    final Collection&lt;V&gt; coll = map.get(key);<a name="line.163"></a>
<FONT color="green">164</FONT>                    return coll == null ? 0 : coll.size();<a name="line.164"></a>
<FONT color="green">165</FONT>            }<a name="line.165"></a>
<FONT color="green">166</FONT>            @Override<a name="line.166"></a>
<FONT color="green">167</FONT>            public boolean isEmpty() {<a name="line.167"></a>
<FONT color="green">168</FONT>                    return map.isEmpty();<a name="line.168"></a>
<FONT color="green">169</FONT>            }<a name="line.169"></a>
<FONT color="green">170</FONT>            @Override<a name="line.170"></a>
<FONT color="green">171</FONT>            public boolean contains(Object key) {<a name="line.171"></a>
<FONT color="green">172</FONT>                    return map.containsKey(key);<a name="line.172"></a>
<FONT color="green">173</FONT>            }<a name="line.173"></a>
<FONT color="green">174</FONT>            public boolean contains(Object key, V value) {<a name="line.174"></a>
<FONT color="green">175</FONT>                    final Collection&lt;V&gt; coll = map.get(key);<a name="line.175"></a>
<FONT color="green">176</FONT>                    return coll == null ? false : coll.contains(value);<a name="line.176"></a>
<FONT color="green">177</FONT>            }<a name="line.177"></a>
<FONT color="green">178</FONT>            /**<a name="line.178"></a>
<FONT color="green">179</FONT>             * Returns all values belonging to this key, i.e. the value collection is<a name="line.179"></a>
<FONT color="green">180</FONT>             * cleared<a name="line.180"></a>
<FONT color="green">181</FONT>             * <a name="line.181"></a>
<FONT color="green">182</FONT>             * @param key   the key which identifies the value collection<a name="line.182"></a>
<FONT color="green">183</FONT>             * <a name="line.183"></a>
<FONT color="green">184</FONT>             * @return      true if this map has changed as a consequence of this <a name="line.184"></a>
<FONT color="green">185</FONT>             *                      operation<a name="line.185"></a>
<FONT color="green">186</FONT>             * @throws UnsupportedOperationException if this is an immutable map<a name="line.186"></a>
<FONT color="green">187</FONT>             */<a name="line.187"></a>
<FONT color="green">188</FONT>            @Override<a name="line.188"></a>
<FONT color="green">189</FONT>            public boolean remove(Object key) {<a name="line.189"></a>
<FONT color="green">190</FONT>                    return map.remove(key) != null;<a name="line.190"></a>
<FONT color="green">191</FONT>            }<a name="line.191"></a>
<FONT color="green">192</FONT>            /**<a name="line.192"></a>
<FONT color="green">193</FONT>             * Returns a single value of the value collection, if it exists<a name="line.193"></a>
<FONT color="green">194</FONT>             * <a name="line.194"></a>
<FONT color="green">195</FONT>             * @param key   the key which identifies the value collection<a name="line.195"></a>
<FONT color="green">196</FONT>             * @param value the value to remove<a name="line.196"></a>
<FONT color="green">197</FONT>             * <a name="line.197"></a>
<FONT color="green">198</FONT>             * @return      true if this map has changed as a consequence of this <a name="line.198"></a>
<FONT color="green">199</FONT>             *                      operation<a name="line.199"></a>
<FONT color="green">200</FONT>             * @throws UnsupportedOperationException if this is an immutable map<a name="line.200"></a>
<FONT color="green">201</FONT>             */<a name="line.201"></a>
<FONT color="green">202</FONT>            @Override<a name="line.202"></a>
<FONT color="green">203</FONT>            public boolean remove(Object key, V value) {<a name="line.203"></a>
<FONT color="green">204</FONT>                    final Collection&lt;V&gt; coll = map.get(key);<a name="line.204"></a>
<FONT color="green">205</FONT>                    if (coll == null) return false;<a name="line.205"></a>
<FONT color="green">206</FONT>                    if (coll.remove(value)) {<a name="line.206"></a>
<FONT color="green">207</FONT>                            if (coll.isEmpty()) {<a name="line.207"></a>
<FONT color="green">208</FONT>                                    map.remove(key);<a name="line.208"></a>
<FONT color="green">209</FONT>                            }<a name="line.209"></a>
<FONT color="green">210</FONT>                            return true;<a name="line.210"></a>
<FONT color="green">211</FONT>                    }<a name="line.211"></a>
<FONT color="green">212</FONT>                    return false;<a name="line.212"></a>
<FONT color="green">213</FONT>            }<a name="line.213"></a>
<FONT color="green">214</FONT>            <a name="line.214"></a>
<FONT color="green">215</FONT>            /**<a name="line.215"></a>
<FONT color="green">216</FONT>             * Removes all entries from this mapping<a name="line.216"></a>
<FONT color="green">217</FONT>             * <a name="line.217"></a>
<FONT color="green">218</FONT>             * @return      true if this mapping has changed as a consequence of this <a name="line.218"></a>
<FONT color="green">219</FONT>             *                      operation<a name="line.219"></a>
<FONT color="green">220</FONT>             * @throws UnsupportedOperationException if this is an immutable map<a name="line.220"></a>
<FONT color="green">221</FONT>             */<a name="line.221"></a>
<FONT color="green">222</FONT>            @Override<a name="line.222"></a>
<FONT color="green">223</FONT>            public boolean clear() {<a name="line.223"></a>
<FONT color="green">224</FONT>                    if (!map.isEmpty()) {<a name="line.224"></a>
<FONT color="green">225</FONT>                            map.clear();<a name="line.225"></a>
<FONT color="green">226</FONT>                            return true;<a name="line.226"></a>
<FONT color="green">227</FONT>                    }<a name="line.227"></a>
<FONT color="green">228</FONT>                    return false;<a name="line.228"></a>
<FONT color="green">229</FONT>            }<a name="line.229"></a>
<FONT color="green">230</FONT>            <a name="line.230"></a>
<FONT color="green">231</FONT>            /**<a name="line.231"></a>
<FONT color="green">232</FONT>             * Returns an modifiable key set, i.e. removal of keys is also reflected in <a name="line.232"></a>
<FONT color="green">233</FONT>             * this multi value map<a name="line.233"></a>
<FONT color="green">234</FONT>             * <a name="line.234"></a>
<FONT color="green">235</FONT>             * @see MultiValueMap#get(Object)<a name="line.235"></a>
<FONT color="green">236</FONT>             */<a name="line.236"></a>
<FONT color="green">237</FONT>            public Set&lt;K&gt; keySet() {<a name="line.237"></a>
<FONT color="green">238</FONT>                    return map.keySet();<a name="line.238"></a>
<FONT color="green">239</FONT>            }<a name="line.239"></a>
<FONT color="green">240</FONT>            <a name="line.240"></a>
<FONT color="green">241</FONT>            /**<a name="line.241"></a>
<FONT color="green">242</FONT>             * Returns an unmodifiable iterator for all values<a name="line.242"></a>
<FONT color="green">243</FONT>             * <a name="line.243"></a>
<FONT color="green">244</FONT>             * @see MultiValueMap#values()<a name="line.244"></a>
<FONT color="green">245</FONT>             */<a name="line.245"></a>
<FONT color="green">246</FONT>            @Override<a name="line.246"></a>
<FONT color="green">247</FONT>            public Iterable&lt;V&gt; values() {     <a name="line.247"></a>
<FONT color="green">248</FONT>                    return new Iterable&lt;V&gt;() {<a name="line.248"></a>
<FONT color="green">249</FONT>                            public Iterator&lt;V&gt; iterator() {<a name="line.249"></a>
<FONT color="green">250</FONT>                                    return new Iterator&lt;V&gt;() {<a name="line.250"></a>
<FONT color="green">251</FONT>                                            private final Iterator&lt;? extends Iterable&lt;V&gt;&gt; mItIt = map.values().iterator();<a name="line.251"></a>
<FONT color="green">252</FONT>                                            private Iterator&lt;V&gt;       mIt     = nextIterator();<a name="line.252"></a>
<FONT color="green">253</FONT>                                            private Iterator&lt;V&gt; nextIterator() {<a name="line.253"></a>
<FONT color="green">254</FONT>                                                    Iterable&lt;V&gt; itbl = mItIt.hasNext() ? mItIt.next() : null;<a name="line.254"></a>
<FONT color="green">255</FONT>                                                    if (itbl != null) {<a name="line.255"></a>
<FONT color="green">256</FONT>                                                            Iterator&lt;V&gt; it = itbl.iterator();<a name="line.256"></a>
<FONT color="green">257</FONT>                                                            return it.hasNext() ? it : nextIterator();<a name="line.257"></a>
<FONT color="green">258</FONT>                                                    }<a name="line.258"></a>
<FONT color="green">259</FONT>                                                    return null;<a name="line.259"></a>
<FONT color="green">260</FONT>                                            }<a name="line.260"></a>
<FONT color="green">261</FONT>                                            public boolean hasNext() {<a name="line.261"></a>
<FONT color="green">262</FONT>                                                    if (mIt == null) return false;<a name="line.262"></a>
<FONT color="green">263</FONT>                                                    if (mIt.hasNext()) return true;<a name="line.263"></a>
<FONT color="green">264</FONT>                                                    mIt = nextIterator();<a name="line.264"></a>
<FONT color="green">265</FONT>                                                    return hasNext();<a name="line.265"></a>
<FONT color="green">266</FONT>                                            }<a name="line.266"></a>
<FONT color="green">267</FONT>                                            public V next() {<a name="line.267"></a>
<FONT color="green">268</FONT>                                                    if (hasNext()) {<a name="line.268"></a>
<FONT color="green">269</FONT>                                                            return mIt.next();<a name="line.269"></a>
<FONT color="green">270</FONT>                                                    }<a name="line.270"></a>
<FONT color="green">271</FONT>                                                    throw new NoSuchElementException();<a name="line.271"></a>
<FONT color="green">272</FONT>                                            }<a name="line.272"></a>
<FONT color="green">273</FONT>                                            public void remove() {<a name="line.273"></a>
<FONT color="green">274</FONT>                                                    if (mIt == null) throw new NoSuchElementException();<a name="line.274"></a>
<FONT color="green">275</FONT>                                                    mIt.remove();<a name="line.275"></a>
<FONT color="green">276</FONT>                                            }<a name="line.276"></a>
<FONT color="green">277</FONT>                                    };<a name="line.277"></a>
<FONT color="green">278</FONT>                            }<a name="line.278"></a>
<FONT color="green">279</FONT>                    };<a name="line.279"></a>
<FONT color="green">280</FONT>            }<a name="line.280"></a>
<FONT color="green">281</FONT>            <a name="line.281"></a>
<FONT color="green">282</FONT>            /* (non-Javadoc)<a name="line.282"></a>
<FONT color="green">283</FONT>             * @see java.lang.Object#clone()<a name="line.283"></a>
<FONT color="green">284</FONT>             */<a name="line.284"></a>
<FONT color="green">285</FONT>            @SuppressWarnings("unchecked")<a name="line.285"></a>
<FONT color="green">286</FONT>            @Override<a name="line.286"></a>
<FONT color="green">287</FONT>            public DefaultMultiValueMap&lt;K, V&gt; clone() {<a name="line.287"></a>
<FONT color="green">288</FONT>                    try {<a name="line.288"></a>
<FONT color="green">289</FONT>                            final Method meth = map.getClass().getMethod("clone");<a name="line.289"></a>
<FONT color="green">290</FONT>                            final Map&lt;K, Collection&lt;V&gt;&gt; clonedMap = (Map&lt;K, Collection&lt;V&gt;&gt;)meth.invoke(map);<a name="line.290"></a>
<FONT color="green">291</FONT>                            return new DefaultMultiValueMap&lt;K, V&gt;(clonedMap);<a name="line.291"></a>
<FONT color="green">292</FONT>                    } <a name="line.292"></a>
<FONT color="green">293</FONT>                    catch (Exception e) {<a name="line.293"></a>
<FONT color="green">294</FONT>                            //map might not be cloneable, lets just create a new map now<a name="line.294"></a>
<FONT color="green">295</FONT>                            return new DefaultMultiValueMap&lt;K, V&gt;(this);<a name="line.295"></a>
<FONT color="green">296</FONT>                    }<a name="line.296"></a>
<FONT color="green">297</FONT>            }<a name="line.297"></a>
<FONT color="green">298</FONT>            <a name="line.298"></a>
<FONT color="green">299</FONT>            /**<a name="line.299"></a>
<FONT color="green">300</FONT>             * Returns the value collection for the specified key. If no such<a name="line.300"></a>
<FONT color="green">301</FONT>             * collection exists, a new collection is <a name="line.301"></a>
<FONT color="green">302</FONT>             * {@link #createCollection(Object) created} and added to the backing<a name="line.302"></a>
<FONT color="green">303</FONT>             * map.<a name="line.303"></a>
<FONT color="green">304</FONT>             * <a name="line.304"></a>
<FONT color="green">305</FONT>             * @param key           the key identifying the value collection<a name="line.305"></a>
<FONT color="green">306</FONT>             * @return      the value collection<a name="line.306"></a>
<FONT color="green">307</FONT>             */<a name="line.307"></a>
<FONT color="green">308</FONT>            protected Collection&lt;V&gt; getOrCreateCollection(K key) {<a name="line.308"></a>
<FONT color="green">309</FONT>                    Collection&lt;V&gt; coll = map.get(key);<a name="line.309"></a>
<FONT color="green">310</FONT>                    if (coll == null) {<a name="line.310"></a>
<FONT color="green">311</FONT>                            map.put(key, coll = createCollection(key));<a name="line.311"></a>
<FONT color="green">312</FONT>                    }<a name="line.312"></a>
<FONT color="green">313</FONT>                    return coll;<a name="line.313"></a>
<FONT color="green">314</FONT>            }<a name="line.314"></a>
<FONT color="green">315</FONT>            /**<a name="line.315"></a>
<FONT color="green">316</FONT>             * Returns a new collection instance. By default, an {@link ArrayList} of<a name="line.316"></a>
<FONT color="green">317</FONT>             * size one is created. The method shall never return null.<a name="line.317"></a>
<FONT color="green">318</FONT>             * <a name="line.318"></a>
<FONT color="green">319</FONT>             * @param key   the key for which a value collection is to be created<a name="line.319"></a>
<FONT color="green">320</FONT>             * @return              the new array list instance<a name="line.320"></a>
<FONT color="green">321</FONT>             */<a name="line.321"></a>
<FONT color="green">322</FONT>            protected Collection&lt;V&gt; createCollection(K key) {<a name="line.322"></a>
<FONT color="green">323</FONT>                    return new ArrayList&lt;V&gt;(1);<a name="line.323"></a>
<FONT color="green">324</FONT>            }<a name="line.324"></a>
<FONT color="green">325</FONT>            /**<a name="line.325"></a>
<FONT color="green">326</FONT>             * Returns a new map instance. By default, a {@link LinkedHashMap} is <a name="line.326"></a>
<FONT color="green">327</FONT>             * created. The method shall never return null.<a name="line.327"></a>
<FONT color="green">328</FONT>             * <a name="line.328"></a>
<FONT color="green">329</FONT>             * @return              the new linked hash map instance<a name="line.329"></a>
<FONT color="green">330</FONT>             */<a name="line.330"></a>
<FONT color="green">331</FONT>            protected Map&lt;K, Collection&lt;V&gt;&gt; createMap() {<a name="line.331"></a>
<FONT color="green">332</FONT>                    return new LinkedHashMap&lt;K, Collection&lt;V&gt;&gt;();<a name="line.332"></a>
<FONT color="green">333</FONT>            }<a name="line.333"></a>
<FONT color="green">334</FONT>    }<a name="line.334"></a>




























































</PRE>
</BODY>
</HTML>
